#!/bin/sh
# AP mode Scripts
# command : HOSTAPD_WEP.sh <bg> <channel> '<SSID>' '<Password>'
# example : HOSTAPD_WEP.sh g 1 'SSID' 'Password'

help_echo() {
  echo example : HOSTAPD_WEP.sh g 1 \'SSID\' \'Password\'
  exit
}

# mode check (b or g)
if test "$1" != "b" && test "$1" != "g" ; then
   help_echo;
fi

# channel check (1 - 13)
if test $2 -lt 1 || test $2 -gt 13 ; then
   help_echo;
fi

sh /etc/network/wlan-scripts/disconnect_wlan0.sh

ifconfig wlan0 up

HOSTAP_CONF=/etc/hostapd.conf
 
# command : hostapd_conf_base <wlan num>
hostapd_conf_base() {
echo "
interface=$1
driver=nl80211
preamble=1
dtim_period=2
beacon_int=100
logger_syslog=-1
logger_syslog_level=2
logger_stdout=-1
logger_stdout_level=2
dump_file=/tmp/hostapd.dump
ctrl_interface=/var/run/hostapd
ctrl_interface_group=0
max_num_sta=255
macaddr_acl=0
auth_algs=3
wmm_enabled=0
eapol_key_index_workaround=0
eap_server=0
ap_max_inactivity=300
#ap_max_inactivity=4294967295
#skip_inactivity_poll=0
#max_listen_interval=100
own_ip_addr=127.0.0.1
#ap_table_max_size=255
#ap_table_expiration_time=3600
" > $HOSTAP_CONF
}

# command : hostapd_conf_bgn <bgn> <channel>
hostapd_conf_bgn() {
if [ $1 = b ]; then
echo "
country_code=JP
channel=$2
#IEEE802.11b
hw_mode=b
" >> $HOSTAP_CONF
elif [ $1 = g ]; then
echo "
country_code=JP
channel=$2
#IEEE802.11g
hw_mode=g
" >> $HOSTAP_CONF
elif [ $1 = n ]; then
echo "
country_code=JP
channel=$2
#IEEE802.11n
hw_mode=g
ieee80211n=1
#ht_capab=[HT40+][SHORT-GI-40]
" >> $HOSTAP_CONF
fi
}

# command : hostapd_conf_WEP <SSID> <Key0>
hostapd_conf_WEP() {
echo "
# WEP(OPEN/SHARED) --- bg
ssid=$1
wep_rekey_period=0
wpa=0
wpa_group_rekey=0
wpa_strict_rekey=0
wpa_gmk_rekey=0
wpa_ptk_rekey=0
auth_algs=3
wep_default_key=0
wep_key0=$2
#wep_key1=
#wep_key2=
#wep_key3=" >> $HOSTAP_CONF
}

killall hostapd
# hostapd configration
hostapd_conf_base wlan0;
hostapd_conf_bgn $1 $2;
hostapd_conf_WEP $3 $4;
hostapd $HOSTAP_CONF -B
iw reg set JP
ifup wlan0

